#liyuezhou.cm@gmail.com
import sys
import cv2
from dcda_tracker import Dcda_Tracker
from defaults import _C as cfg
from vgg_backbone import build_vgg16
import vot




# warpper
class DCDA(object):
    def __init__(self, image, region):
        model = build_vgg16(cfg)
        device = 'cuda'
        gt_bbox = region
        gt_bbox = [int(gt_bbox[0]), int(gt_bbox[1]), int(gt_bbox[2]), int(gt_bbox[3])]
        self.tracker = Dcda_Tracker(cfg, model=model, device=device, display=False)
        self.tracker.initialize_dcda(image, gt_bbox)
    def track(self, image):
        pred_bbox, ps = self.tracker.tracking(image)
        return vot.Rectangle(pred_bbox[0], pred_bbox[1], pred_bbox[2], pred_bbox[3]), ps



# VOT2020 Evaluate

handle = vot.VOT("rectangle")
selection = handle.region()
myregion = list((int(selection.x), int(selection.y), int(selection.width), int(selection.height)))
imagefile = handle.frame()
if not imagefile:
    sys.exit(0)
# init vot
image = cv2.imread(imagefile)
tracker = DCDA(image, myregion)
# run vot
while True:
    imagefile = handle.frame()
    if not imagefile:
        break
    image = cv2.imread(imagefile)
    region, confidence = tracker.track(image)
    handle.report(region, confidence)
